=== debian/changelog ===
ros-eloquent-sophus (1.1.0-1bionic) bionic; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Daniel Stonier <d.stonier@gmail.com>  Sun, 13 Oct 2019 23:57:09 -0000
